#!/bin/bash

set -o errexit
set -o nounset
set -o pipefail

if [ -z "${OS:-}" ]; then
  echo "OS must be set"
  exit 1
fi
if [ -z "${ARCH:-}" ]; then
  echo "ARCH must be set"
  exit 1
fi
if [ -z "${VERSION:-}" ]; then
  echo "VERSION mus be set"
  exit 1
fi

export CGO_ENABLED=0
export GOARCH="${ARCH}"
export GOOS="${OS}"
export GO111MODULE=on
export GOFLAGS="-mod=vendor"

go install                                                    \
  -installsuffix "static"                                     \
  -ldflags "-x $(go list -m)/pkg/version.VERSION=${VERSION}"  \
  ./...
